/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/config.js":
/*!***********************!*\
  !*** ./src/config.js ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "entriesPerPage": () => (/* binding */ entriesPerPage),
/* harmony export */   "innerBlocksAllowedBlocks": () => (/* binding */ innerBlocksAllowedBlocks)
/* harmony export */ });
var _window$dmgLiveblogSe, _window, _window$dmgLiveblogSe2;

/**
 * The number of entries loaded in per page
 *
 * @type {Number}
 */
const entriesPerPage = 25;
/**
 * Array of whitelisted Gutenberg block names for use in the InnerBlocks component
 *
 * @type {string[]}
 */

let whitelist = (_window$dmgLiveblogSe = (_window = window) === null || _window === void 0 ? void 0 : (_window$dmgLiveblogSe2 = _window.dmgLiveblogSettings) === null || _window$dmgLiveblogSe2 === void 0 ? void 0 : _window$dmgLiveblogSe2.blockWhitelist) !== null && _window$dmgLiveblogSe !== void 0 ? _window$dmgLiveblogSe : [];
const innerBlocksAllowedBlocks = ['core/image', 'core/paragraph', 'core/list', 'core/quote', 'core/embed', 'core-embed/twitter', 'core-embed/youtube', 'core-embed/facebook', 'core-embed/instagram', 'getty-images/media'].concat(whitelist);

/***/ }),

/***/ "./src/liveblog-editor/components/load-more.js":
/*!*****************************************************!*\
  !*** ./src/liveblog-editor/components/load-more.js ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   "loadEntries": () => (/* binding */ loadEntries)
/* harmony export */ });
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/data */ "@wordpress/data");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_data__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @wordpress/api-fetch */ "@wordpress/api-fetch");
/* harmony import */ var _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _config__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../config */ "./src/config.js");


/**
 * WordPress dependencies
 */



/**
 * Internal dependencies
 */


/**
 * Load in entries
 */

const loadEntries = page => {
  const postId = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)('core/editor').getCurrentPostId();
  const endpoint = `wp/v2/liveblog/${postId}/entries?context=edit&per_page=${_config__WEBPACK_IMPORTED_MODULE_3__.entriesPerPage}&page=${page}`; // POST to create a new entry

  _wordpress_api_fetch__WEBPACK_IMPORTED_MODULE_2___default()({
    path: endpoint,
    method: 'GET',
    parse: false
  }).then(res => {
    // Check if we've hit max pages
    const maxPages = res.headers.get('X-Wp-Totalpages');

    if (page >= maxPages) {
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('dmg/liveblog').setHasHitMaxPages(true);
    }

    return res.json();
  }).then(json => {
    const rawBlocks = json.map(entry => {
      var _entry$content;

      return entry === null || entry === void 0 ? void 0 : (_entry$content = entry.content) === null || _entry$content === void 0 ? void 0 : _entry$content.raw;
    }); // Filter out blocks that aren't already stored i.e. via Key Event selection

    const newBlocks = wp.blocks.parse(rawBlocks.join("\n\n")).filter(block => {
      var _block$attributes;

      return (block === null || block === void 0 ? void 0 : (_block$attributes = block.attributes) === null || _block$attributes === void 0 ? void 0 : _block$attributes.entryId) && !(0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)('dmg/liveblog').getBlockByEntryId(block.attributes.entryId);
    }); // Add new blocks to the store

    newBlocks.forEach(block => {
      var _block$attributes2;

      if (block !== null && block !== void 0 && (_block$attributes2 = block.attributes) !== null && _block$attributes2 !== void 0 && _block$attributes2.entryId) {
        (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('dmg/liveblog').setBlockByEntryId(block.attributes.entryId, block);
      }
    }); // Insert the new blocks

    if (!(0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)('dmg/liveblog').hasFinishedInitialLoad()) {
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('core/block-editor').insertBlocks(newBlocks, 1, '', false);
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('dmg/liveblog').setHasFinishedInitialLoad(true);
    } else {
      (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('core/block-editor').insertBlocks(newBlocks, (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)('core/editor').getBlocks().length, '', false);
    }
  });
};
/**
 * Create a component for loading in more entries
 */

const LoadMore = _ref => {
  let {
    hasHitMaxPages,
    hasFinishedInitialLoad
  } = _ref;
  const [page, setPage] = (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.useState)(1); // Load in more entries

  const loadMore = () => {
    const newPage = page + 1;
    setPage(newPage);
    loadEntries(newPage);
  }; // CSS class names


  let cssClasses = ['dmg-liveblog__entry-load-more'];

  if (!hasFinishedInitialLoad) {
    cssClasses.push('dmg-liveblog__entry-load-more--loading');
  } // Button text display


  let text = hasFinishedInitialLoad ? 'Load More' : 'Loading entries...';
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, !hasHitMaxPages && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: cssClasses.join(' '),
    onClick: loadMore
  }, text));
};
/**
 * Fetch the author
 *
 * @param {Object}   select                       Data store selector.
 * @return {Object} The liveblog object
 */


/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.withSelect)(select => {
  // Get state flags
  const hasHitMaxPages = select('dmg/liveblog').hasHitMaxPages();
  const hasFinishedInitialLoad = select('dmg/liveblog').hasFinishedInitialLoad();
  return {
    hasHitMaxPages,
    hasFinishedInitialLoad
  };
})(LoadMore));

/***/ }),

/***/ "./src/store.js":
/*!**********************!*\
  !*** ./src/store.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/data */ "@wordpress/data");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_data__WEBPACK_IMPORTED_MODULE_0__);
/**
 * WordPress dependencies
 */

const DEFAULT_STATE = {
  blocks: {},
  hasFinishedInitialLoad: false,
  hasHitMaxPages: false,
  keyEvents: []
};
const actions = {
  // Add a block to the store by its post ID
  setBlockByEntryId(entryId, block) {
    return {
      type: 'SET_BLOCK_BY_ENTRY_ID',
      entryId,
      block
    };
  },

  // Set flag when we've finished initial load
  setHasFinishedInitialLoad(hasFinishedInitialLoad) {
    return {
      type: 'SET_HAS_FINISHED_INITIAL_LOAD',
      hasFinishedInitialLoad
    };
  },

  // Set flag when we've queried the max number of pages
  setHasHitMaxPages(hasHitMaxPages) {
    return {
      type: 'SET_HAS_HIT_MAX_PAGES',
      hasHitMaxPages
    };
  },

  // Set the entire array of key events
  setKeyEvents(keyEvents) {
    return {
      type: 'SET_KEY_EVENTS',
      keyEvents
    };
  },

  // Add key event to store
  addKeyEvent(entry) {
    return {
      type: 'ADD_KEY_EVENT',
      entry
    };
  },

  // Remove key event from store
  removeKeyEventByEntryId(entryId) {
    return {
      type: 'REMOVE_KEY_EVENT_BY_ENTRY_ID',
      entryId
    };
  }

};
const store = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_0__.createReduxStore)('dmg/liveblog', {
  reducer() {
    let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_STATE;
    let action = arguments.length > 1 ? arguments[1] : undefined;

    switch (action.type) {
      // Add a block to the entries list by using the corresponding 
      // entry ID as the object key
      case 'SET_BLOCK_BY_ENTRY_ID':
        return { ...state,
          blocks: { ...state.blocks,
            [action.entryId]: action.block
          }
        };
      // Update the bool value for if we've finished initial load

      case 'SET_HAS_FINISHED_INITIAL_LOAD':
        return { ...state,
          hasFinishedInitialLoad: action.hasFinishedInitialLoad
        };
      // Update the bool value for if we've hit max pages

      case 'SET_HAS_HIT_MAX_PAGES':
        return { ...state,
          hasHitMaxPages: action.hasHitMaxPages
        };
      // Set the entire array of key events

      case 'SET_KEY_EVENTS':
        return { ...state,
          keyEvents: action.keyEvents
        };
      // Add a key event and make sure we sort by date

      case 'ADD_KEY_EVENT':
        let updatedKeyEvents = state.keyEvents; // Look if the entry already exists

        let existingKey = false;
        updatedKeyEvents.forEach((entry, key) => {
          if (entry.id === action.entry.id) {
            existingKey = key;
          }
        });

        if (existingKey === false) {
          // Entry doesn't exist; add it
          updatedKeyEvents.push(action.entry);
        } else {
          // Entry exists already; update it
          updatedKeyEvents[existingKey] = action.entry;
        }

        return { ...state,
          keyEvents: updatedKeyEvents.sort((a, b) => {
            return new Date(b.date) - new Date(a.date);
          })
        };
      // Remove key event by entry ID by filtering the array

      case 'REMOVE_KEY_EVENT_BY_ENTRY_ID':
        return { ...state,
          keyEvents: state.keyEvents.filter(entry => {
            return entry.id !== action.entryId;
          })
        };
    }

    return state;
  },

  actions,
  selectors: {
    // Get a block by post object ID
    getBlockByEntryId(state, entryId) {
      const {
        blocks
      } = state;
      const block = blocks[entryId];
      return block;
    },

    // Get all blocks in the editor as a post ID => block map
    getBlocks(state) {
      const {
        blocks
      } = state;
      return blocks;
    },

    // Get all key events
    getKeyEvents(state) {
      const {
        keyEvents
      } = state;
      return keyEvents;
    },

    // Flag for if we've finished initial load
    hasFinishedInitialLoad(state) {
      const {
        hasFinishedInitialLoad
      } = state;
      return hasFinishedInitialLoad;
    },

    // Flag for if we've hit max pages
    hasHitMaxPages(state) {
      const {
        hasHitMaxPages
      } = state;
      return hasHitMaxPages;
    }

  }
});
(0,_wordpress_data__WEBPACK_IMPORTED_MODULE_0__.register)(store);

/***/ }),

/***/ "./src/utils.js":
/*!**********************!*\
  !*** ./src/utils.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _liveblog_entry_block_json__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./liveblog-entry/block.json */ "./src/liveblog-entry/block.json");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/data */ "@wordpress/data");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_data__WEBPACK_IMPORTED_MODULE_1__);
/**
 * Internal dependencies
 */


/**
 * Insert a new entry form
 */

const insertNewEntryForm = () => {
  const insertedBlock = wp.blocks.createBlock(_liveblog_entry_block_json__WEBPACK_IMPORTED_MODULE_0__.name, {
    date: new Date().toISOString(),
    author: (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)("core").getCurrentUser().id
  });
  wp.data.dispatch('core/block-editor').insertBlocks(insertedBlock, 0);
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (insertNewEntryForm);

/***/ }),

/***/ "./src/liveblog-editor/styles.scss":
/*!*****************************************!*\
  !*** ./src/liveblog-editor/styles.scss ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ }),

/***/ "@wordpress/api-fetch":
/*!**********************************!*\
  !*** external ["wp","apiFetch"] ***!
  \**********************************/
/***/ ((module) => {

module.exports = window["wp"]["apiFetch"];

/***/ }),

/***/ "@wordpress/data":
/*!******************************!*\
  !*** external ["wp","data"] ***!
  \******************************/
/***/ ((module) => {

module.exports = window["wp"]["data"];

/***/ }),

/***/ "@wordpress/element":
/*!*********************************!*\
  !*** external ["wp","element"] ***!
  \*********************************/
/***/ ((module) => {

module.exports = window["wp"]["element"];

/***/ }),

/***/ "./src/liveblog-entry/block.json":
/*!***************************************!*\
  !*** ./src/liveblog-entry/block.json ***!
  \***************************************/
/***/ ((module) => {

module.exports = JSON.parse('{"title":"DMG Liveblog Entry","description":"A single liveblog entry.","name":"dmg/liveblog-entry","category":"layout","icon":"id-alt","attributes":{"entryId":{"type":"number","default":""},"title":{"type":"string","default":""},"date":{"type":"string","default":""},"author":{"type":"number","default":""},"authorOverride":{"type":"number","default":""},"keyEvent":{"type":"boolean","default":false},"hideByline":{"type":"boolean","default":false}}}');

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!**************************************!*\
  !*** ./src/liveblog-editor/index.js ***!
  \**************************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/data */ "@wordpress/data");
/* harmony import */ var _wordpress_data__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_data__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../utils */ "./src/utils.js");
/* harmony import */ var _components_load_more__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./components/load-more */ "./src/liveblog-editor/components/load-more.js");
/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../store */ "./src/store.js");
/* harmony import */ var _styles_scss__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./styles.scss */ "./src/liveblog-editor/styles.scss");


/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




 // Bool for if we did initial loading

let didInitialLoad = false; // Define ID for the components

const LOAD_MORE_ID = 'dmg-liveblog-entry-load-more';
/**
 * Stream in the latest entries
 */

const initiateEntriesStream = () => {
  var _document, _document$location;

  // No need to fetch initial entries on new liveblog
  if (((_document = document) === null || _document === void 0 ? void 0 : (_document$location = _document.location) === null || _document$location === void 0 ? void 0 : _document$location.pathname) === '/wp-admin/post-new.php') {
    return null;
  } // Set the key events


  const keyEvents = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)('core/editor').getEditedPostAttribute('key_events');
  (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('dmg/liveblog').setKeyEvents(keyEvents);
  (0,_components_load_more__WEBPACK_IMPORTED_MODULE_3__.loadEntries)(1);
};
/**
 * Subscribe to changes so we can insert the appender
 */


const unsubscribe = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.subscribe)(() => {
  // Check if post is ready
  const postId = (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.select)('core/editor').getCurrentPostId();

  if (!postId) {
    return;
  } // Check if the root container is ready


  const rootContainer = document.querySelector('.is-root-container.block-editor-block-list__layout');

  if (!rootContainer) {
    return;
  }

  unsubscribe(); // Remove the permalink meta box

  (0,_wordpress_data__WEBPACK_IMPORTED_MODULE_1__.dispatch)('core/edit-post').removeEditorPanel('post-link'); // Add the Load More button

  const loadMoreContainer = document.createElement('div');
  loadMoreContainer.id = LOAD_MORE_ID;
  loadMoreContainer.classList.add('wp-block');
  ReactDOM.render((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_load_more__WEBPACK_IMPORTED_MODULE_3__["default"], null), rootContainer.parentNode.insertBefore(loadMoreContainer, rootContainer.nextSibling)); // @TODO see if there's a way we can do this without setTimeout

  setTimeout(() => {
    (0,_utils__WEBPACK_IMPORTED_MODULE_2__["default"])();
    initiateEntriesStream();
  }, 500);
});
})();

/******/ })()
;
//# sourceMappingURL=dmg-liveblog-editor.js.map